#include "MatPat.h"
#include <string.h>


BOOL MatchPattern(unsigned char *raw, unsigned char *pat)
{
    int  i, slraw;

    if( (*pat == '\0') && (*raw == '\0') )                    /*  if it is end of both   */
        return TRUE;                                          /*  strings,then match     */

    if( *pat == '\0' )                                        /*  if it is end of only   */
        return FALSE;                                         /*  pat then mismatch      */

    if( *pat == '*' )                                         /* if pattern is a '*'     */
    {
        if( *(pat+1) == '\0' )                                /*    if it is end of pat  */
            return TRUE;                                      /*    then match           */

        for( i=0, slraw=strlen((char *)raw); i <= slraw; i++ )/*    else hunt for match  */
            if( (*(raw+i) == *(pat+1)) ||                     /*         or wild card    */
                (*(pat+1) == '?') )
                if( MatchPattern( raw+i+1, pat+2 ) == TRUE )  /*      if found,match     */
                    return TRUE;                              /*        rest of pat      */
    }
    else
    {
        if( *raw == '\0' )                                    /*  if end of raw then     */
            return FALSE;                                     /*     mismatch            */

        if( (*pat == '?') || (*pat == *raw ) )                /*  if chars match then    */
         if( MatchPattern( raw+1, pat+1 ) == 1 )              /*  try & match rest of it */
            return TRUE;
     };
    return FALSE;                                             /*  no match found         */
};
