#ifndef __Locale_H
#define __Locale_H

#define MAX_ALPHABET_LEN 128
#define MAX_BREAKKEY_CNT 80
#define MAX_KBD_LAYOUTS 5

typedef struct //_BreakKeysItem
{
    char Symbol;
    int ScanCode;
}BreakKeysItem;

int CharCompare(const void *a, const void *b);
int ScanCodeCompare(const void *a, const void *b);

class TLocale
{
public:
    int KeyboardLayoutCnt;
    char Alphabets[MAX_KBD_LAYOUTS][MAX_ALPHABET_LEN];
    int AlphabetLengths[MAX_KBD_LAYOUTS];
    char BreakSymbols[MAX_KBD_LAYOUTS][MAX_BREAKKEY_CNT];
    int BreakKeys[MAX_KBD_LAYOUTS][MAX_BREAKKEY_CNT];

    TLocale(void);
    ~TLocale(void);

    void GetLocales( void );
    int GetStringLocale( char * String );
};

#endif